/**
 * Copyright 2008 Peach Jean Solutions
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *     http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.xj4.parameterized;

/**
 * @author jbunting
 * @TODO Document Me!
 * Created by IntelliJ IDEA.
 * Date: Mar 3, 2008
 * Time: 8:54:45 AM
 */
public abstract class AbstractParameterSet implements ParameterSet {
  protected String[] definedLabels;
  protected String name;

  public AbstractParameterSet(String name, String[] definedLabels) {
    this.name = name;
    this.definedLabels = definedLabels == null ? new String[0] : definedLabels;
  }

  public String getName() {
    return name == null ? defaultName() : name;
  }

  public String getIterationLabel(int iteration) {
    return iteration < definedLabels.length ? definedLabels[iteration] : defaultLabel(iteration); 
  }

  public void setLabels(String[] labels) {
    definedLabels = labels;
  }

  public void setName(String name) {
    this.name = name;
  }

  protected abstract String defaultLabel(int iteration);

  protected abstract String defaultName();
}
