/**
 * Copyright 2008 Peach Jean Solutions
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *     http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.xj4.parameterized;

import org.apache.commons.lang.NullArgumentException;

/**
 * @author jbunting
 * @TODO Document Me!
 * Created by IntelliJ IDEA.
 * Date: Mar 3, 2008
 * Time: 8:29:58 AM
 */
public class IndexParameterSet extends AbstractParameterSet {

  private ParameterSet subSet;

  public IndexParameterSet(ParameterSet subSet) {
    this(null, null, subSet);
  }

  public IndexParameterSet(String name, String[] labelArray, ParameterSet subSet) {
    super(name, labelArray);
    this.subSet = subSet;
  }

  public int getNumIterations() {
    return subSet.getNumIterations();
  }

  public Object[] getIteration(int iteration) {
    return new Object[] { iteration };
  }

  protected String defaultLabel(int iteration) {
    return String.format("(%s)#", subSet.getIterationLabel(iteration));
  }

  protected String defaultName() {
    return subSet.getName() + "#";
  }

  public int getIterationSize() {
    return 1;
  }

  public void validate() {
    if(subSet == null) {
      throw new NullArgumentException("SubDefinition cannot be null!");
    }
  }
}
