/**
 * Copyright 2008 Peach Jean Solutions
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *     http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.xj4.parameterized;

/**
 * @author jbunting
 * @TODO Document Me!
 * Created by IntelliJ IDEA.
 * Date: Mar 3, 2008
 * Time: 11:43:29 AM
 */
public class SingleValueParameterSet extends AbstractSimpleParameterSet {

  public SingleValueParameterSet(Object[] iterationArray) {
    super(null, null, iterationArray);
  }

  public SingleValueParameterSet(Object[] iterationArray, String[] labels) {
    super(null, labels, iterationArray);
  }

  public SingleValueParameterSet(String name, String[] definedLabels, Object[] iterationArray) {
    super(name, definedLabels, iterationArray);
  }

  public int getIterationSize() {
    return 1;
  }

  public Object[] getIteration(int iteration) {
    return new Object[] { getIterationArray()[iteration] };
  }

  @Override
  public void validate() {
    // do nothing - this is overriding the attempt to check for null iterations in the parent
  }
}
